<template>
  <q-drawer
    :model-value="drawer"
    side="left"
    bordered
    class="q-mt-lg"
  >
    <q-scroll-area style="height: 100%;">
      <q-list>
        <q-item
          v-for="timetable in timetableAll"
          :key="timetable.id"
        >
          <q-item-section>
            <q-btn
              color="primary"
              :label="timetable.name"
              flat
              @click="timetableDetailClick(timetable.id)"
            />
          </q-item-section>
          <q-item-section
            v-if="user.canCrudHwAdmin"
            side
          >
            <q-btn
              color="primary"
              icon="play_circle_filled"
              @click="timetableClick(timetable)"
            />
          </q-item-section>
        </q-item>
      </q-list>

      <q-list>
        <q-item
          v-for="journey in journeyAll"
          :key="journey.id"
        >
          <q-item-section>
            <q-btn
              color="primary"
              :label="journeyLabel(journey)"
              flat
              @click="journeyDetailClick(journey.id)"
            />
          </q-item-section>
          <q-item-section
            v-if="user.canCrudHwAdmin"
            side
          >
            <q-btn
              color="primary"
              icon="play_circle_filled"
              @click="journeyClick(journey)"
            />
          </q-item-section>
        </q-item>
      </q-list>
    </q-scroll-area>
  </q-drawer>
</template>

<script lang="ts">
import { defineComponent, ref } from '@vue/runtime-core'
import { useQuasar } from 'quasar'
import { JourneyModel, TimetableModel } from 'web_trains_types'

import JourneyAddDialog from '@/components/Timetable/JourneyAddDialog.vue'
import TimetableAddDialog from '@/components/Timetable/TimetableAddDialog.vue'
import { adminMapService, journeyService, timetableService } from '@/service'
import userStore from '@/store/userStore'

export default defineComponent({
  name: 'TrainDrawer',
  props: {
    drawer: {
      type: Boolean,
      required: true
    }
  },
  setup (): any {
    const user = userStore()
    const $q = useQuasar()

    const timetableAll = ref<TimetableModel[]>()
    const journeyAll = ref<JourneyModel[]>()

    $q.loading.show()

    journeyService.getAll()
      .then((data) => {
        journeyAll.value = data
      })
      .finally(() => {
        $q.loading.hide()
      })

    timetableService.getAll()
      .then((data) => {
        timetableAll.value = data
      })
      .finally(() => {
        $q.loading.hide()
      })

    const journeyClick = (journey: JourneyModel) => {
      adminMapService.runJourney(journey.id)
        .then((res) => {
          if (res) {
            if (!res) {
              return
            }

            $q.notify({
              message: journeyService.getLabel(journey) + ' bude spuštěno',
              type: 'positive'
            })
          }
        })
    }

    const timetableClick = (timetable: TimetableModel) => {
      adminMapService.runTimetable(timetable.id)
        .then((res) => {
          if (res) {
            if (!res) {
              return
            }

            $q.notify({
              message: timetable.name + ' bude spuštěn',
              type: 'positive'
            })
          }
        })
    }

    const journeyDetailClick = (id:number) => {
      $q.dialog({
        component: JourneyAddDialog,
        componentProps: {
          id: id,
          detail: true
        }
      })
    }

    const timetableDetailClick = (id:number) => {
      $q.dialog({
        component: TimetableAddDialog,
        componentProps: {
          id: id,
          detail: true
        }
      })
    }

    return {
      user,
      timetableAll,
      journeyAll,
      journeyLabel: journeyService.getLabel,
      journeyClick,
      timetableClick,
      journeyDetailClick,
      timetableDetailClick
    }
  }
})

</script>
